<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE xsl:stylesheet [
  <!ENTITY copy "&#169;">
  <!ENTITY nbsp "&#160;">
  <!ENTITY lk "/webcenter_page/user_lang_key">
]>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:Lang="com.esko.webcenter.jsp.LanguageMgr" exclude-result-prefixes="Lang">
  <xsl:import href="template.xsl"/>
  <xsl:import href="attributetemplates.xsl"/>
  <xsl:import href="templatedate.xsl"/>
  <xsl:import href="docdetails_template.xsl"/>

  <xsl:variable name="useTableBodyContainer" select="false()" />
  
  
 
  <!-- override templates to prevent them showing anything -->

  <xsl:template name="welcomeEtc" />

  <xsl:template name="headerUserActions"/>
  <xsl:template name="headerMenuBar"/>
  <xsl:template name="headerMenuScripts"/>
  
  <xsl:template name="isWizardPage">
    <xsl:value-of select="true()"/>
  </xsl:template>
  
  <xsl:template name="isNameLink">
    <xsl:value-of select="false()"/>
  </xsl:template>
    
  <xsl:template name="bodyextensions">
    <xsl:attribute name="onload">SetInitialFocus();</xsl:attribute>
  </xsl:template>

  <xsl:variable name="isEditable" select="(/webcenter_page/is_editable = 'true') or (/webcenter_page/is_editable = '1')"/>
	  
    <!-- 
  
            template that controls the generation of the body content
            
  -->
  <xsl:template name="bodycontent">
	<xsl:variable name="dynamicAttr" select="category/category_XML"/>
	<xsl:variable name="returnPage" select="/webcenter_page/componentreturnurl"/>

 	 <!-- Confirmation section -->
    <xsl:call-template name="DisplayNotification"/>
    <xsl:call-template name="DisplayAttrSaveNotification"/>	
	  
    <xsl:choose>
    	<!-- No Category assigned : display the appropriate message -->
    	<xsl:when test="no_attr_category_msg">
    		<div class="alert alert-info" role="alert">
    			<xsl:value-of select="Lang:getStr(&lk;,'DOCHASNOATTRSCATEGORY_TAG')"/>
    		</div>
	    	<div class="form-group">
	    		<label class="offset-label"></label>
	    		<div class="form-entry">
	    			<input type="button" name="Return" value="{Lang:getStr(&lk;,'RETURN')}" title="{Lang:getStr(&lk;,'RETURN')}"
	          			 onclick="returnButtonClicked('{$returnPage}');" class="btn btn-primary"/>
       			 </div>
    		</div>
    	</xsl:when>
    	<xsl:otherwise>
			<form name="actionform" method="post" action="dodocdetailsactions.jsp" enctype="MULTIPART/FORM-DATA" class="wcr-form">	
				<input type="hidden" name="actionVal" value="SaveAttributes"/>
				<input type="hidden" name="attributeCategoryReturnPage">
						<xsl:attribute name="value"><xsl:value-of select="/webcenter_page/attrcatviewreturnurl"/></xsl:attribute>
				</input>
				<xsl:call-template name="docDetailsHiddenInputs"/>

				<!-- firefox needs submit button for actual submission -->
				<input type="submit" style="display:none;" />

				<div id="ACatObj"></div>
				<div id="ACatPanel"></div>
			</form>
    	</xsl:otherwise>
    </xsl:choose>

  	<xsl:call-template name="AttributeActionButtons">
  		<xsl:with-param name="action" select="'dodocdetailsactions.jsp'"/>
  		<xsl:with-param name="importActionValue" select="'ImportDocumentAttrsFromXML'"/>
  		<xsl:with-param name="exportActionValue" select="'ExportDocumentAttrsToXML'"/>
  		<xsl:with-param name="changeActionValue" select="'SaveAttributes'" />
  		<xsl:with-param name="inputTemplateName" select="'docDetailsHiddenInputs'"/>
		<xsl:with-param name="showImportExportFunctionality" select="false()"/>
		<xsl:with-param name="showReturn" select="true()"/>
		<xsl:with-param name="returnPage" select="/webcenter_page/componentreturnurl"/>
  	</xsl:call-template>
    
	 
  </xsl:template>
  
    
<!-- 
  
            template that controls the inclusion of javascript functionality 
            
  -->
  <xsl:template name="scriptincs">
    <script src="javascript/validate.js"/>&#xA;
	<script src="javascript/TableSelection.js"/>&#xA;
    <style>
      #ui-datepicker-div
      {
      z-index: 9999999;
      }
    </style>
    <script type="text/javascript">
      <xsl:text disable-output-escaping="yes">&lt;!--</xsl:text>&#xA;
		function OpenNewWindow(href)
		{
		  window.open(href);
		}
		
        function PrintWindow(newWindow)
        {
			var location = '';
			if (newWindow)
				location += 'javascript:OpenNewWindow("';
			location += 'docdetailsattrs.jsp?docVerID=<xsl:value-of select="/webcenter_page/doc_version/@id"/>'; 
			<xsl:if test="count(/webcenter_page/attrcatview)>0">
				location += '&amp;attrcatview=<xsl:call-template name="encodejs"><xsl:with-param name="string" select="/webcenter_page/attrcatview"/></xsl:call-template>';
			</xsl:if>						 
			<xsl:if test="count(/webcenter_page/pagetitle)>0">
				location += '&amp;pagetitle=<xsl:call-template name="encodejs"><xsl:with-param name="string" select="/webcenter_page/pagetitle"/></xsl:call-template>';
			</xsl:if>						 
			<xsl:if test="count(/webcenter_page/showimage)>0">
				location += '&amp;showimage=<xsl:call-template name="encodejs"><xsl:with-param name="string" select="/webcenter_page/showimage"/></xsl:call-template>';
			</xsl:if>						 
			<xsl:if test="count(/webcenter_page/maxpixsize)>0">
				location += '&amp;maxpixsize=<xsl:call-template name="encodejs"><xsl:with-param name="string" select="/webcenter_page/maxpixsize"/></xsl:call-template>';
			</xsl:if>						 
			<xsl:if test="count(/webcenter_page/maxpixsizex)>0">
				location += '&amp;maxpixsizex=<xsl:call-template name="encodejs"><xsl:with-param name="string" select="/webcenter_page/maxpixsizex"/></xsl:call-template>';
			</xsl:if>						 
			<xsl:if test="count(/webcenter_page/maxpixsizey)>0">
				location += '&amp;maxpixsizey=<xsl:call-template name="encodejs"><xsl:with-param name="string" select="/webcenter_page/maxpixsizey"/></xsl:call-template>';
			</xsl:if>						 
			if (newWindow)
				location += '&amp;print=1");';
			else
				location += '&amp;print=1&amp;menu_file=<xsl:call-template name="encodejs"><xsl:with-param name="string" select="/webcenter_page/menu_file"/></xsl:call-template>';
//			alert(location);
			window.location = location;
						
			return;  				
        }
        
		<xsl:if test="/webcenter_page/doc_version/category_id">
		
		require(["attributecategory/AttributeCategory", "utils/ObjectArrayCloneUtil"], function(AttributeCategory, ObjectHandler){
			$(function() {
				<!-- aCatOptions.projectID is project ID for projects and template ID for templates. -->
			    <xsl:variable name="projTempID">
			        <xsl:choose>
			          <xsl:when test="/webcenter_page/project_list/project/@id">
			          	<xsl:value-of select="/webcenter_page/project_list/project/@id"/>
			          </xsl:when>
			          <xsl:otherwise>
			          	<xsl:value-of select="/webcenter_page/template_list/project_list/project/@id"/>
			          </xsl:otherwise>
			        </xsl:choose>
			    </xsl:variable>
			    
			    var currentUser = ObjectHandler.getCloneOfObject(gCurrentUser);
				currentUser.canEditAttributes = <xsl:value-of select="$isEditable"/>;
		
				var readURL = "GetAttributeCategoryXML.jsp?categoryid=" + '<xsl:value-of select="/webcenter_page/doc_version/category_id"/>';
				// ensure to only append the category's mod date when it is known
				<xsl:if test="/webcenter_page/category/mod_time_stamp">
					readURL  += '&amp;lastmodified='+ <xsl:value-of select="/webcenter_page/category/mod_time_stamp"/> ;
				</xsl:if>
				var valuesURL = "GetAttributes.jsp?docverid="+'<xsl:value-of select="/webcenter_page/doc_version/@id"/>';
		
				var aCatOptions = new Object();
				aCatOptions.ACatObj = "ACatObj";
				aCatOptions.ACatPanel = "ACatPanel";
				aCatOptions.readURL = readURL;
				aCatOptions.currentUser = currentUser;
				aCatOptions.valuesURL = valuesURL;
				<xsl:if test="count(/webcenter_page/attrcatview)>0">
					aCatOptions.view='<xsl:call-template name="encodejs"><xsl:with-param name="string" select="/webcenter_page/attrcatview"/></xsl:call-template>';
					aCatOptions.readURL += '&amp;view=<xsl:call-template name="encodejs"><xsl:with-param name="string" select="/webcenter_page/attrcatview"/></xsl:call-template>';
				</xsl:if>
				aCatOptions.defaultHourAsHalfHours = <xsl:value-of select="/webcenter_page/default_due_date_time"/>;
				aCatOptions.type = "document";
				aCatOptions.projectID = '<xsl:value-of select="$projTempID"/>';
				aCatOptions.documentID = '<xsl:value-of select="/webcenter_page/doc_version/document/@id"/>';
				aCatOptions.docVersionID = '<xsl:value-of select="/webcenter_page/doc_version/@id"/>';
				if (aCatOptions.docVersionID) {
					// to be used to detect cyclic dependencies in document references
					aCatOptions.docTableParentDocVerIDs = [aCatOptions.docVersionID];
				}
				myACat = new AttributeCategory(aCatOptions);

			    // myACat is a global variable that is sometimes overwritten. this is a safe solution
				var docACatObj = myACat;
				
			    // add trigger to warn user when leaving the page with unsaved changes
			    window.onbeforeunload = function() {
			    	if ((docACatObj.attributesChanged === true) &amp;&amp; !docACatObj.submitInProgress) {
			    		return '<xsl:call-template name="encodejs"><xsl:with-param name="string" select="Lang:getStr(&lk;,'ACatConfirmPageExit')"/></xsl:call-template>';
			    	}
			    };
			});
		});
		</xsl:if>
      <xsl:text disable-output-escaping="yes">//--&gt;</xsl:text>&#xA;
    </script>

	<xsl:call-template name="AttributeTemplateJavaScript"/>	
  </xsl:template>

</xsl:stylesheet>
